if _G.AllTheGadgets then return end --you know what they say about the number of chefs in the meal preparation area

local orig_toggle_gadget = NewRaycastWeaponBase.toggle_gadget
function NewRaycastWeaponBase:toggle_gadget(current_state,...)
	if not LasersPlus:IsMultiGadgetEnabled() then
		return orig_toggle_gadget(self,current_state,...)
	end
	
	if not self._enabled then return false end
	
	local gadget_on = self._gadget_on or 0
	local gadgets = self._gadgets or managers.weapon_factory:get_parts_from_weapon_by_type_or_perk("gadget", self._factory_id, self._blueprint)
	
	if gadgets then
		local num_gadgets = #gadgets
		local gadget_combo_count
		if LasersPlus:IsGadgetOverloadEnabled() then
			gadget_on = (gadget_on - 1) % 2
		else
--			gadget_combo_count = math.pow(num_gadgets,2) + num_gadgets --max number of combinations between any 2 gadgets (old v2.42 behavior)
			gadget_combo_count = math.pow(2,num_gadgets) --max number of nonrepeating combinations between any combination of gadgets (including 0 gadgets, single gadgets, all gadgets, etc)
			gadget_on = (gadget_on + 1) % (gadget_combo_count) --current combination index; effectively, #of gadget-toggle keypresses
		end
		self._gadget_on = gadget_on
		self:set_gadget_on(gadget_on,false,gadgets,current_state)
		return true
	end

	return false
end

local orig_set_gadget_on = NewRaycastWeaponBase.set_gadget_on
function NewRaycastWeaponBase:set_gadget_on(gadget_on, ignore_enable, gadgets, current_state,...)
	if not LasersPlus:IsMultiGadgetEnabled() then 
		return orig_set_gadget_on(self,gadget_on,ignore_enable,gadgets,current_state,...)
	end
	
	if not ignore_enable and not self._enabled then return end
	if not self._assembly_complete then return end
	
	self._gadget_on = gadget_on or self._gadget_on
	local gadget = nil
	
	gadget_on = gadget_on or self._gadget_on or 0
	gadgets = self._gadgets or gadgets or managers.weapon_factory:get_parts_from_weapon_by_type_or_perk("gadget", self._factory_id, self._blueprint)
	
	if gadgets then
		if not LasersPlus:IsGadgetOverloadEnabled() then
			for i, id in ipairs(gadgets or self._gadgets) do
				gadget = self._parts[id]
				if gadget and alive(gadget.unit) then
					local gadget_state
					local bitand = bit.band(i,gadget_on)
					gadget_state = bitand ~= 0
					gadget.unit:base():set_state(gadget_state, self._sound_fire, current_state)
				end
			end
		else
			for i, id in ipairs(gadgets or self._gadgets) do
				gadget = self._parts[id]

				if gadget and alive(gadget.unit) then
					gadget.unit:base():set_state(gadget_on ~= 0, self._sound_fire, current_state)
				end
			end
		end
	end
end
